=== debian/changelog ===
ros-foxy-openvslam (0.2.4-2focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- ymd-stella <world.applepie@gmail.com>  Sat, 25 Dec 2021 20:30:07 -0000
